
setwd("N://Alfonso_Gomez//2 - Raw Image Files//181017_Endosome_Escape_dV//CellProfAnalys")

Masked_virus <- read.csv2("dV_EndEsc_Local_Maskedvirus.csv", header = T, sep = ",")

##Set your treatments and your times

library("stringr")

add_my_numbers1 <- function(data){
  a <- str_split_fixed(data$Metadata_sample,"_",n = 3)
  L <- a[,3]
  data <- cbind(data, "Treatment"=L)
  return(data)
}

Con_time <- add_my_numbers1(Masked_virus)

#### Con_time$Treatment <- gsub("Mock","Mock_0min", Con_time$Treatment)

add_my_numbers2 <- function(data){
  a <- str_split_fixed(data$Treatment,"_",n = 2)
  L <- as.character(a[,1])
  N <- as.numeric(str_split_fixed(a[,2],"",n = 2)[,1])
  data <- cbind(data, "Condition"=L,"time"=N)
  return(data)
}

Con_time <- add_my_numbers2(Con_time)

Con_time <- as.data.frame(Con_time)



######
## Now its time to count the viruses (Pos, Neg,...)
######
## First transform the columns of the signals into numbers (not characters)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}


Con_time$Intensity_MeanIntensity_pVI <- as.numeric.factor(Con_time$Intensity_MeanIntensity_pVI)
Con_time$Intensity_MeanIntensity_Hex <- as.numeric.factor(Con_time$Intensity_MeanIntensity_Hex)

library("ggplot2")
## Check that your sample is complete
ggplot()+
  geom_point(data = Con_time,aes(x = Metadata_sample, y = Metadata_Site), size = 0.5)

## Check the intensitites
ggplot()+
  geom_point(data = Con_time,aes(x = Metadata_sample,y = Intensity_MeanIntensity_pVI), size=0.5)+
  ylab("pVII intensity in Virus Particles")+
  xlab("Treatment")+
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

ggplot(data = Con_time,aes(x = Metadata_sample,y = Intensity_MeanIntensity_pVI))+
  geom_boxplot(color = "grey") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("pVI Intensity in VP") +
  theme_classic()+
  ylim(c(0, 0.2)) +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))


Con_time$Treatment <- factor(Con_time$Treatment, levels = c("dV_0min","wt_0min","dV_10min","wt_10min","dV_20min","wt_20min","dV_30min","wt_30min","dV_60min","wt_60min"))

## Convert those treatments into numbers so the analysis will be easier

Con_time$Treatment <- gsub("Mock_0min","1", Con_time$Treatment)
Con_time$Treatment <- gsub("dV_0min","2", Con_time$Treatment)
Con_time$Treatment <- gsub("dV_10min","3", Con_time$Treatment)
Con_time$Treatment <- gsub("dV_20min","4", Con_time$Treatment)
Con_time$Treatment <- gsub("dV_30min","5", Con_time$Treatment)
Con_time$Treatment <- gsub("dV_60min","6", Con_time$Treatment)
Con_time$Treatment <- gsub("wt_0min","7", Con_time$Treatment)
Con_time$Treatment <- gsub("wt_10min","8", Con_time$Treatment)
Con_time$Treatment <- gsub("wt_20min","9", Con_time$Treatment)
Con_time$Treatment <- gsub("wt_30min","10", Con_time$Treatment)
Con_time$Treatment <- gsub("wt_60min","11", Con_time$Treatment)

Con_time$Treatment <- as.numeric(Con_time$Treatment)

Con_time$Treatment[1700]

##Set your background

back_dV <- subset(Con_time, Con_time$Metadata_sample =="181017_Endosome_dV_0min")
back_wt <- subset(Con_time, Con_time$Metadata_sample =="181017_Endosome_wt_0min")

bpVI_dV <- back_dV[which(back_dV$Intensity_MeanIntensity_pVI >= 0.165),]
bpVI_wt <- back_wt[which(back_wt$Intensity_MeanIntensity_pVI >= 0.135),]


## Proceed with the counting

output2 <- matrix(nrow = 0, ncol = 7)

cell_counting <- function(exp,trt){
  for (i in 2:trt) {
    g <- subset(exp, (exp$Treatment == i))
    msite <- max(g$Metadata_Site, na.rm = T)
    for (k in 0:msite) {
      p <- subset(exp, (exp$Treatment == i) & (exp$Metadata_Site == k))
      ncel <- max(p$Parent_Cell, na.rm = T)
      for (c in 1:ncel) {
        cells <- length(p[p[,"Parent_Cell"] == c,][,1])
        if (i < 7) {
          pVIpos <- length(p[(p[,"Parent_Cell"] == c & p["Intensity_MeanIntensity_pVI"] >= 0.165),][,1])
        } else {
          pVIpos <- length(p[(p[,"Parent_Cell"] == c & p["Intensity_MeanIntensity_pVI"] >= 0.135),][,1])
        }
        Percentpos <- (pVIpos/cells)*100
        if (is.nan(Percentpos)){
          Percentpos <- 0
        }
        output2 <- rbind(output2,c(i, i, k, c, cells, pVIpos, Percentpos))
      }
    }
    
  }
  return(output2)
}

?is.nan

EndEsc_cellcount <- cell_counting(Con_time,11)
colnames(EndEsc_cellcount) <- c("Condition", "Treatment", "Site", "Cell", "Virus_particles", "pVI_VP_pos", "Percent_pVI_pos")

EndEsc_cellcount <- as.data.frame(EndEsc_cellcount)

### Add again the treatments column so your graphs will look preattier

##EndEsc_cellcount$Condition <- gsub("1", "Mock_0min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("2", "dV_0min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("3", "dV_1Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("dV_1Omin","dV_10min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("4", "dV_2Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("dV_2Omin","dV_20min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("5", "dV_3Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("dV_3Omin","dV_30min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("6", "dV_6Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("dV_6Omin","dV_60min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("7", "wt_0min", EndEsc_cellcount$Condition)

EndEsc_cellcount$Condition <- gsub("8", "wt_1Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("wt_1Omin","wt_10min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("9", "wt_2Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("wt_2Omin","wt_20min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("10", "wt_3Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("wt_3Omin","wt_30min", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("11", "wt_6Omin", EndEsc_cellcount$Condition)
EndEsc_cellcount$Condition <- gsub("wt_6Omin","wt_60min", EndEsc_cellcount$Condition)

write.csv2(EndEsc_cellcount, file = "181022_Endosme_dV_SingleCell_Analysis.csv", row.names = T)

setwd("N://Alfonso_Gomez//1 - Experimental Procedures//180515_LngEndEsc//CellProfAnalys")

EndEsc_cellcount <- read.csv2("180515_LngEndEsc_SingleCell_Analysis.csv", header = T)

EndEsc_cellcount_APEX <- subset(EndEsc_cellcount, EndEsc_cellcount$Treatment < 7)

EndEsc_cellcount_wt <- subset(EndEsc_cellcount, EndEsc_cellcount$Treatment > 6)

## Plot the cells against the %of positive pVI
install.packages("reshape2")
library(reshape2)

ggplot()+
  geom_point(data = EndEsc_cellcount,aes(x = Condition,y = Percent_pVI_pos), size=0.5)+
  ylab("Percentage of pVI pos per cell")

ggplot()+
  geom_boxplot(data = EndEsc_cellcount,aes(x = Condition,y = Percent_pVI_pos)) +
  geom_dotplot(data = EndEsc_cellcount,aes(x = Condition,y = Percent_pVI_pos), binaxis='y', stackdir='center',
               stackratio=1, dotsize=0.3, position = "dodge") +
  ylab("Percentage of pVI pos per cell")

ggplot(data = EndEsc_cellcount,aes(x = Condition,y = Percent_pVI_pos))+
  geom_boxplot(color = "black") +
  geom_jitter(size = 1.3, color = "grey") +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("Virus particles per cell") +
  ylim(c(0, 40)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

ggplot(data = EndEsc_cellcount,aes(x = Condition,y = Virus_particles))+
  geom_boxplot(color = "grey") +
  geom_jitter(size = 1.5) +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  ylab("Virus particles per cell") +
  ylim(c(0, 200)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

# Plot with Luca ----------------------------------------------------------

head(EndEsc_cellcount)
levels(EndEsc_cellcount$virus)
str(EndEsc_cellcount$virus)

library(stringr)
EndEsc_cellcount['virus'] <- str_match(string = EndEsc_cellcount$Condition, pattern = '(.*)[_^](.*)')[,2]
EndEsc_cellcount['time'] <- str_match(string = EndEsc_cellcount$Condition, pattern = '(.*)[_^](.*)')[,3]

EndEsc_cellcount$virus <- factor(EndEsc_cellcount$virus)
View(EndEsc_cellcount)
EndEsc_cellcount$virus <- factor(EndEsc_cellcount$virus, levels = c('wt', 'dV'))

ggplot(data = EndEsc_cellcount,aes(x = time, y = Percent_pVI_pos))+
  geom_dotplot(binaxis='y', stackdir='center',
               stackratio=0.01, dotsize=0.3, alpha=0.5, position = position_jitter(width = 0.2)) +
  geom_boxplot(color = "black", outlier.colour = NA) +
  stat_summary(fun.data=mean_sdl, fun.args = list(mult=1), 
               geom="pointrange", color="red") +
  facet_grid(.~virus)+
  ylab("Percentage of positive VI VP per cell") +
  ylim(c(0, 30)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1, colour = 'black'), axis.ticks = element_line(colour = 'black'))+
  theme(axis.text.y = element_text(colour = 'black'))

data_summary <- function(x) {
  m <- mean(x)
  ymin <- m-sd(x)
  ymax <- m+sd(x)
  return(c(y=m,ymin=ymin,ymax=ymax))
}

#########
########
#########

## Calculate the VP number per treatment

Calc_my_meansd <- function(cellcount){
  ni <- cellcount$Treatment[1]
  nf <- cellcount$Treatment[dim(cellcount)[1]]
  matrix <- matrix(nrow = nf-ni+1,ncol = 6)
  for (i in ni:nf) {
    Treat <- i
    Total_cell <- dim(cellcount[cellcount$Treatment == i,])[1]
    Total_VP <- sum(cellcount$Virus_particles[cellcount$Treatment == i])
    Mean_VP <- mean(cellcount$Virus_particles[cellcount$Treatment == i])
    SD_VP <- sd(cellcount$Virus_particles[cellcount$Treatment == i])
    if (i < (ni+nf)/2){
      VP_cell_ul <- Mean_VP/2.4
    } else {
      VP_cell_ul <- Mean_VP/1.96
    }
    update <- c(Treat,Total_cell, Total_VP, Mean_VP, SD_VP, VP_cell_ul)
    matrix[i-ni+1,] <- update  
  }
  return(matrix)
}

mean_and_VP <- Calc_my_meansd(EndEsc_cellcount)
colnames(mean_and_VP) <- c("Treatment","Total_cell","Total_VP_condition","Mean_VP_cell", "SD", "VPperCellperul")

mean_and_VP <- as.data.frame(mean_and_VP)

write.csv2(mean_and_VP, file = "181022_Endosme_dV_VP_mean.csv", row.names = T)
